//#pragma sequential
//
//   Dive sort
//
//   uses sparse array features in Javascript
//
//
var N = 2000;
var precision = 5;

var a = [];
var b = [];
var a_sparse = [];
var a_orig = [];
var a_res = [];
var t = [];
var b_max;
var a_min = 0;
var i, j, k;

// Sample unsorted array 
for (i = 0; i < N; i++) {
    a[i] = 1000*Math.random();
    a_orig[i] = a[i];
    if (a[i] < 0) {    // find the minimum negative value
	a_min = a[i];
    }
}

//some more mess
a[0] = 3;
a[1] = 10.5;
a[2] = -2;
a[3] = 3;

for (i = 0; i < N; i++) {
    a_orig[i] = a[i];
    if (a[i] < 0) {    // find the minimum negative value
	a_min = a[i];
    }
}

// Make all values positive
for (i = 0; i < N && a_min < 0; i++) {
    a[i] = a[i] - a_min;
}

// Some magic to normalize numbers to integers
// (so bobber with weigh always sink)
for (i = 0; i < N; i++) {
    b[i] = ''+a[i]*Math.pow(10, precision);
    t = b[i].split(".");
    b[i] = parseInt(t[0]);
}
b_max = 0;

//real sorting starts here
for (i = 0; i < N; i++) {
    if (a_sparse[b[i]] != undefined) {
	if (!Array.isArray(a_sparse[b[i]])) {  
	    // same or similar values are added to the stack
	    t = a_sparse[b[i]];
	    a_sparse[b[i]] = [];
	    a_sparse[b[i]].push(t);
	}
        a_sparse[b[i]].push(a_orig[i]);
        console.log(a_sparse[b[i]]);
    }
    else {
	a_sparse[b[i]] = a_orig[i];
    }
    if (b[i] > b_max) b_max = b[i];
}
console.log(b_max);
// retrieve sorted values from sparse array
for (i = 0, j = 0; j <= b_max; j++) {
    if (a_sparse[j] != undefined) {
	if (Array.isArray(a_sparse[j])) {
	    // if some values are too close they may
	    // get into one bucket (slot),
	    // so we use built-in array sort, because
	    // total amount of them very little
	    a_sparse[j].sort(function(a,b){return a-b});
	    for (k = 0; k < a_sparse[j].length; k++) {
		a_res[i] = a_sparse[j][k];
		i++;
	    }
	}
	else {
	    a_res[i] = a_sparse[j];
	    i++;
	}
    }
}

console.log(a_res);
console.log(a_res.length);
